
ConsoleProtocol = class(
	function (self)
	end
	);
	
function ConsoleProtocol:CreatePlayerUpdate(player)
	return sprintf("PLAYER\1%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\0", 
					player.Id, player.Name, player.Class1, player.Class2, player.Class3, player.Level, player.Level2, player.Level3, player.Guild, 
					player.HP, player.MaxHP, player.MP, player.MaxMP, player.MP2, player.MaxMP2, 
					player.Race, player.X, player.Y, player.Z, player.Mounted, player.LastExp);	
end;

function ConsoleProtocol:CreatePlayerCoordsUpdate(player)
	return sprintf("PLAYERUPD\1%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\0", player.Name, player.HP, player.MaxHP, player.X, player.Y, player.Z, getZoneId(), player.MP, player.MaxMP, player.MP2, player.MaxMP2);
end

function ConsoleProtocol:CreateInventoryUpdate(inventory)
	inventory:update(nil);
	local result = "ITEMS\1";
 	for slot,item in pairs(inventory.BagSlot) do
	    if (item.Available and (not item.Empty)) then
			result = sprintf("%s%s\3%s\3%s\3%s\3%s\3%s\3%s\3%s\3%s\3%s\3%s\2",
							result, item.Name, item.ItemCount, item.SlotNumber, item.ItemLink, 
							item.Durability, item.Quality, item.BoundStatus, item.RequiredLvl, item.ObjType, 
							item.ObjSubType, item.ObjSubSubType);
			
			--result = result..item.Id.." - "..item.Name.."["..item.ItemCount.."]\n";
		end;
	end;
	
	return result.."\0";
end

function ConsoleProtocol:CreateErrorMessage(message)
	return sprintf("ERROR\1%s\0", message);
end

function ConsoleProtocol:CreatePlayerCoordsUpdate(player)
	return sprintf("PLAYERUPD\1%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\2%s\0", player.Name, player.HP, player.MaxHP, player.X, player.Y, player.Z, getZoneId(), player.MP, player.MaxMP, player.MP2, player.MaxMP2);
end

function ConsoleProtocol:CreateInitMessage()
	return sprintf("INIT\1%s\2%s\0", getHwnd(), getWin());
end;

function ConsoleProtocol:CreateChatMessage(channel, from, msg, date)
	return sprintf("CHAT\1%s\1%s\1%s\1%s\0", channel, getPlayerNameFromLink(from), stripColorCodes(msg), date)
end;

function getPlayerNameFromLink(playerLink)
	if playerLink == "" or playerLink == nil then
		return "";
 	end

	local s,e, name = string.find(playerLink, "|Hplayer:(.+).*|h%[");
	name = name or "<unknown>";

	return name;
end

function stripColorCodes(source)
	if (source == "") or (source == nil) then
		return "";
	end
	
	if (type(source) == "boolean") then return "true"; end;
	
	print("Stripping: "..source.."\n");
	
	source = string.gsub(source, "|Hitem:(%x+).*|h|c(%x+)", "");
	source = string.gsub(source, "|H|h|c%x%x%x%x%x%x%x%x", "");
	source = string.gsub(source, "|c%x%x%x%x%x%x%x%x", "");
	source = string.gsub(source, "|h", "");
	source = string.gsub(source, "%]|r", "]");
	return source;
end

function ConsoleProtocol:CreateStateUpdate()
	return sprintf("STATE\1%s\2%s\0", tostring(__botState.allowTargetting), tostring(__botState.gameMonitors.active));
end;

__CP = ConsoleProtocol();