--[[
	Encapsulates the logic for moving the player to a waypoint
]]

include("../state.lua");

MOVE_FAILED = 0;
MOVE_SUCCEEDED = 1;

HoldKeyState = class(State);

function HoldKeyState:constructor(args)
	self.name = "HoldKeyState";
	
-- parameters
	--for k,v in pairs(args) do
	--	printf("["..tostring(k).."] "..tostring(v).."\n");
	--end;

	self.key = args.key;
	self.duration = (args.duration or 10)/1000;
	--printf("new duration: "..tostring(self.duration).."\n");
	self.releaseAtEnd = args.releaseAtEnd or true;
	self.start = os.clock();
	self.shouldEnd = self.start+self.duration;
	self.ignoreCombatEvent = args.ignoreCombatEvent or false;
	self.isFirstCycle = true;
end

function HoldKeyState:update()
	logger:log(LL_DEBUG_STATES,self:toString()..":update()");
	
	if (__botState.allowTargetting == true) then
		--printf(self:toString().." searching for enemy\n");
		local t = player:findEnemy(false,nil,evalTargetDefault);
		
		if (t ~= nil) then
			player:target(t);
			stateman:popState(self:toString().." found target");
			return;
		end;
		
	end;
	
	if (self.isFirstCycle == true) then
		keyboardHold( self.key );
	end;
	self.isFirstCycle = false;

	if (os.clock() > self.shouldEnd) then
		if (self.releaseAtEnd == true) then
			keyboardRelease( self.key );
		end;
		stateman:popState(self:toString());
	end;
	
	if ((os.clock()+GAME_MONITOR_MIN_TIME) < self.shouldEnd) then
		stateman:pushEvent("MonitorChats", self:toString(), {["mustBeDoneBy"]=self.shouldEnd});
	end;
	
end

function HoldKeyState:handleEvent(event)
	if (event == "Combat") then
		if (self.ignoreCombatEvent == true) then
			return true;
		else
			keyboardRelease(self.key);
			stateman:popState(self:toString().." interrupted by combat");
		end;
	elseif (event=="Idle") then
		return true;
	end
end

function HoldKeyState:clearState()
end;


table.insert(events,{name = "HoldKey", func = HoldKeyState})
