--[[
	Child of State class.
]]

include("../state.lua");

IdleState = class(State);

function IdleState:constructor()
	self.name = "Idle";
	self.ticker = 1;
	self.haveRun = false;
	local matches = settings.profile.options.INV_AUTOTRASH_MATCHES or '';
	self.trashList = SplitString(matches, ',');
	self.trashValue = settings.profile.options.INV_AUTOTRASH_VALUE or 0;
	self.trashQuality = settings.profile.options.INV_AUTOTRASH_QUALITY or 0;
end

function IdleState:update()
	logger:log(LL_INFO, "IdleState:update()");
	logMessage("IdleState:update()");

	if (player:checkPotions() or player:checkSkills()) then
		player.LastDistImprove = os.time();
	end;

--[[
	if (not self.haveRun) then
		self.haveRun = true;
		
		local wpl = CWaypointList();
		wpl:load(getExecutionPath().."/waypoints/Xav-Butterflies.xml", true);
		stateman:pushEvent("WaypointListExecuter", "Idle", { waypointList=wpl, waypointListName="AT2LocalSnoop" });
		return;
	end;
]]--
	
	if (not player:haveTarget()) and (__botState.allowTargetting) then
		local t = player:findEnemy(false,nil,evalTargetDefault);
		if (t) then
			player:target(t);
			stateman:pushEvent("Combat", self:toString());
			return;
		end;
	end;
	
	if (self.ticker == 1) then
		if (self.trashQuality > 0) then
			CleanBag(self.trashValue, self.trashQuality);
		end;
		if (#self.trashList > 0) then
			CleanBagMatch(self.trashList);
		end;
	end;
	
	self.ticker = self.ticker + 1;
	if (self.ticker >= 100) then
		self.ticker = 1;
	end;
	
	stateman:pushEvent("MonitorChats", self:toString(), {});

--[[	
	local zoneId = getZoneId();
	if (zoneId == 400) then
		stateman:pushEvent("FarmHousemaids");
	end;
]]--


end

function IdleState:handleEvent(event)
	if (event == "Idle") then
		--check to make sure whoever is attacking us isn't the same as our existing target - i.e. we are running away and have run into somoene else!
		return true;
	--elseif (event == "Combat") then
--		stateman:pushState(CombatState());
	end;
	return false;
end

table.insert(events,{name = "Idle", func = IdleState})