--[[
	Encapsulates the logic for moving the player to a waypoint
]]

include("../state.lua");

LS_START = 0;
LS_MOVINGTO = LS_START + 1;
LS_GETTING = LS_MOVINGTO + 1;

LootAllState = class(State);



function LootAllState:constructor(args)
	self.name = "LootAllState";

-- parameters
	self.currentState = LS_START;
	self.allowTargetAquisition = args.allowTargetAquisition or false;
	self.oldAllowTargetting = __botState.allowTargetting;
end

function LootAllState:update()
	logger:log(LL_DEBUG_STATES,self:toString()..":update()");

	inventory:update();
	
	if inventory:itemTotalCount(0) == 0 then
		if( settings.profile.options.DEBUG_LOOT) then
			cprintf(cli.yellow, "[DEBUG] don't loot all reason: inventory is full\n");
		end;
		stateman:popState(self:toString().." inventory is full");
		__botState.allowTargetting = self.oldAllowTargetting;
		return
	end

	player:updateBattling()
	if( player.Battling  and player:findEnemy(true,nil,evalTargetDefault)) then
		stateman:popState(self:toString());
		__botState.allowTargetting = self.oldAllowTargetting;
		return;
	end

	local Lootable = player:findNearestNameOrId("", nil, evalTargetLootable)

	if Lootable == nil then
		stateman:popState(self:toString().." nothing more to loot");
		__botState.allowTargetting = self.oldAllowTargetting;		
		return;
	else
		Lootable = CPawn(Lootable.Address)
	end

	player:target(Lootable)
	player:updateTargetPtr()
	if player.TargetPtr ~= 0 then -- Target's still there.
		player:loot()
		if player:findEnemy(true, nil, evalTargetDefault) then
			-- not looting because of aggro
			stateman:popState(self:toString().." not looting as we have aggro");
			__botState.allowTargetting = self.oldAllowTargetting;
			return
		end
		yrest(50)
		Lootable:updateLootable();
		if Lootable.Lootable == true then
			-- Failed to loot. Add to ignore list
			lootIgnoreListPos = lootIgnoreListPos + 1
			if lootIgnoreListPos > settings.profile.options.LOOT_IGNORE_LIST_SIZE then lootIgnoreListPos = 1 end
			lootIgnoreList[lootIgnoreListPos] = Lootable.Address
		end
	end

end

function LootAllState:handleEvent(event)
	if (event == "Combat") and (self.ignoreCombatEvent == true) then
		return true;
	end
end

function LootAllState:clearState()
end;


table.insert(events,{name = "LootAll", func = LootAllState})
