setExecutionPath(getExecutionPath().."/..")
include "geom.lua";

--Targetting - killzone
KS_emptyBagCount = 7;
KS_old_evalTargetDefault = evalTargetDefault;
KS_target_rect = nil;


function KSevalTargetFunc(address, target)
	local canTarget = KS_old_evalTargetDefault(address, target);
	if ((canTarget) and (KS_target_rect)) then
		--check that target is in current box
		return PointInKillRect(target.X, target.Z);
	end;
	
	return canTarget;
end;
evalTargetDefault=KSevalTargetFunc;

function KSSetKillZone(_rect)
	PrintLine("Setting KillZone to "..tostring(_rect));
	KS_target_rect = _rect;
	if (_rect ~= nil) then
		KSorigin = Point(_rect[1].X, 0, _rect[1].Z);
		KSv1 = Point(_rect[2].X, 0, _rect[2].Z);
		KSv2 = Point(_rect[3].X, 0, _rect[3].Z);
		KSv1 = KSv1-KSorigin;
		KSv2 = KSv2-KSorigin;
		KSdp_v1_v1 = KSv1..KSv1;
		KSdp_v2_v2 = KSv2..KSv2;
	else
	end;
end;

function PointInKillRect(_x, _z)
	local pt = Point(_x,0,_z);
	local v = pt-KSorigin;
	
--	printf("evaluting target in rect: "..tostring(KSorigin).." : "..tostring(KSv1).." : "..tostring(KSv2).."\n");
--	printf("point: "..tostring(pt).."\n");
	

	
	local dp_v_v1 =  v..KSv1;
	local dp_v_v2 = v..KSv2;
	
	local result = (dp_v_v1 > 0);
	if (result == true) then result = (dp_v_v1 < KSdp_v1_v1); end;
	if (result == true) then result = (dp_v_v2 > 0); end;
	if (result == true) then result = (dp_v_v2 < KSdp_v2_v2); end;

	return result;
end


function PrintLine(_text)
	KSLog(tostring(os.date("%c"))..": ".._text);
	if (KS_DEBUG == true) then printf(tostring(os.date("%c"))..": ".._text.."\n"); end;
end;

--Utils
function pause()
	local sk = startKey;
	if( getVersion() >= 100 ) then sk = getStartKey(); end;
	printf(language[160],	-- Script paused until you revive yourself
		getKeyName(sk))
	logMessage("Player died.\n");
	stopPE();
end

function CheckForFullInventory()
	PrintLine("Clearing bags");
	CleanBag(300,3);
	if KS_emptyBagCount >= inventory:itemTotalCount(0)  then    
		player:clearTarget();
		sendMacro("LeaveParty();");
		waitForLoadingScreen(10); 
		player:update();
		KSSetKillZone(nil);
		KS_StartTime = os.time();
		__WPL:setWaypointIndex(__WPL:findWaypointTag("rerun"));	
	end 
end

function KS_LootAll()
	printf("LootAll: enabling looting\n");
	settings.profile.options.LOOT=KS_allow_loot;
	settings.profile.options.LOOT_ALL=KS_allow_loot;
	printf("LootAll: Looting...\n");
	player:lootAll();
	printf("LootAll: disabling further looting\n");
	settings.profile.options.LOOT=false;
	settings.profile.options.LOOT_ALL=false;
end;

function KSLog(_comment)
	__logWithTime("KS.log", _comment);
end

function KSResetInstance()
	PrintLine("Resetting instance");
	local zone = getZoneId();
	if (zone ~= 6) then 
		KS_ExpectingAddressChange = true;
		player:clearTarget();
		sendMacro("LeaveParty();");
		waitForLoadingScreen(30); 
		player:update();
	end;
	
	if ((zone == 6) or (KS_ExpectingAddressChange)) then
		PrintLine("We are still expecting an address change! We shouldn't be as the KSOnPlayerAddressChanged() function should have reset it.");
		--expected an address change, but it didnt - we need to manually exit dungeon
		--recall to logar and run back!!!!
		local cooldown, remaining = sendMacro("GetSkillCooldown(1,9);")
		if (remaining > 1) then return; end;
		RoMScript('CastSpellByName("Transport: Logar")');
		waitForLoadingScreen(30); 
		player:update();
		loadPaths("LogarToDDC");
		return;
	end;
	
	changeProfileOption("MAX_TARGET_DIST", ks_old_maxTargetDist);
	KSSetKillZone(nil);
	KS_StartTime = os.time();
	__WPL:setWaypointIndex(__WPL:findWaypointTag("rerun"));	
end;

function KSOnPlayerAddressChanged()
	printf("!!!!!!!!!!!!!!!!Player address changed!!!!\n");
	if (KS_ExpectingAddressChange == false) then
		--we changed zone for some unknown reason
		if (getZoneId() == 6) then
			loadPaths("KS_WIP");
		else
			return;
		end;
	end;
	
	KS_ExpectingAddressChange = false;
end;

