include("queue.lua");

ZONE_HOUSE = 400;
GLOBAL_COMMAND_ID_SEED = 1;

CController = class(
	function(self)
		self.config = {};
		
		--Daily Quest to run
		self.config.daily = {};
		self.config.daily.Id = 424180;
		self.config.daily.StarterId = 118072;
		self.config.daily.StarterZone = 14;
		self.config.daily.EnderId = 118072;
		self.config.daily.EnderZone = 14;
		
		--Housemaid types
		local housemaids = {};
		local maid = {id=113803, run="1,1", type="cooking"};
		table.insert(housemaids, maid);
		
		maid = {id=113776, run="1,1", type="magic"};
		table.insert(housemaids, maid);
		
		maid = {id=113799, run="1,6", type="crafting"};
		table.insert(housemaids, maid);
		
		self.config.housemaids = housemaids;
		
		
		--State
		self.actionList = CQueue();
		self.currentAction = nil;

		--EVENTS
		self.events = {};
		self.events.onComplete() = function(_state)
			if (_state == WPT_EVENT_FINISHED) then
				--remove from action list --> need a queue here
				if (~self.actionList:isEmpty()) then
					self:SetAction(self.actionList:pop());
				else
					self.currentAction = nil;
				end;
			end;
			self.Think();
		end;
		
		self.think = {};
		self.think.lastCallTime = os.time();
	end
);

-- ***********************	Action management *************************
-- In theory, this method should be called at the end of each action to
-- to move the controller on to the next action. It may also get called
-- if the bot is stuck, or something else occurs - so this needs to be 
-- handled somehow.
function CController:Think()
	local time = os.time();
	local elapsed = time-self.think.lastCallTime;

	if (self.currentAction) then
		--check for errored state (stuck etc)
		return;
	end;

	--if we currently have a plan of action, then do that
	if (~self.actionList:isEmpty()) then
		--are we still performing the current action? or are we ready to move on to the next action;
		self.cur
	end;
	
	--figure out what to do
	-- order: develop housekeeper/plants etc, daily, mini's, other stuff
	if (not HasCompletedDailies()) then
		--get path to daily's
	end;
	
end;

function CController:SetAction(_action)
	self.currentAction = _action;
	__WPL = self.currentAction;
	return;
end;


function CController:HasCompletedDailies()
	local dailyQuestCount, dailyQuestsPerDay = RoMScript("Daily_count()");
	printf(tostring(dailyQuestCount).." of "..tostring(dailyQuestsPerDay).." daily quests completed\n");
	return (dailyQuestCount == dailyQuestsPerDay);
end;


/*
	useGoodie("speed"); -- Unbridled Enthusiasm
	useGoodie("casting"); -- Clear Thought
	useGoodie("luck"); --Turn of Luck Powder Dust
	useGoodie("defense"); --Scarlet Love
	useGoodie("godspeed"); --Godspeed

	useGoodie("pdmg"); -- Housekeeper Special Salted Fish with Sauce
	useGoodie("critp"); -- Housekeeper Special Caviar Sandwich
	useGoodie("patt2"); -- Housekeeper Special Spicy Meatsauce Burrito
	useGoodie("patt3"); -- Housekeeper Special Unimaginable Salad
*/

function HasCompletedDailies()
end;

function CController:HasHousemaidPots()
	local result = true;
	if (countGoodies) then
		if (1 > countGoodies("luck")) return false;
		if (1 > countGoodies("casting")) return false;
		if (1 > countGoodies("pdmg")) return false;
	end;
	return result;
end;

function CController:runHousemaid(_housemaid)
	if (_housemaid) then
		player:target_NPC(_housemaid.id);
		sendMacro("SpeakFrame_ListDialogOption(".._housemaid.run..")");
		yrest(10);
	end;
end

function CController:GotoHouse()
	local pathReq = sprintf("GETROUTENEAREST\1%d\2%d\2%d\2%d\HOUSEMAID\0", player.X, player.Y, player.Z, getZoneId());

	local link = CServerLink();
	local data = link:send(pathReq, true);
	link:close();
	
	local dataArray = SplitString(result, "\1"); -- returns PATH\1NPC
	local path = dataArray[0];
	local npcId = dataArray[1];
	
	local result = CWaypointList();
	result:loadFromString(path);
	
	local wpEnter = result:getLastWaypoint();
	local   action = "local z=getZoneId();\n";
	action = action.."local t=os.time();\n";
	action = action.."while ((z ~= "..tostring(ZONE_HOUSE)..") and (60 > (os.time()-t))) do\n"; //while not in house zone, or it has taken more than 1 minute
	action = action.."  player:target_NPC("..tostring(npcId)..");\n";
	action = action.."  ChoiceOptionByName("enter");\n";
	action = action.."  waitForLoadingScreen(30);\n";
	action = action.."end;";
	wpEnter.Action = action;
end;


function CController:GotoNPC(_zone, _npcid, _uniqueId)
	local uniqueId = "";
	if (_uniqueId) then uniqueId = _uniqueId; end;

	local pathReq = sprintf("GETROUTE\1%d\2%d\2%d\2%d\2%s\2%s\2%s\0", player.X, player.Y, player.Z, getZoneId(), _zone, _npcId, uniqueId);

	local link = CServerLink();
	local path = link:send(pathReq, true);
	link:close();
	
	if (__WPL) then __WPL:performUnload(); end;
	__WPL = CWaypointList();
	__WPL:loadFromString(path);
	__RPL = nil;
end;
